package tool

import (
	"os"

	"github.com/gookit/goutil/fsutil"
	"github.com/huandu/xstrings"
	"github.com/spf13/cast"
	funk "github.com/thoas/go-funk"
)

var (
	ErrorCheck = Asset
	IsDir      = fsutil.IsDir
	PWD        = os.Getwd
	TempDir    = os.TempDir
	ToString   = cast.ToString
	Map        = funk.Map
	Reverse    = xstrings.Reverse
	WordCount  = xstrings.WordCount
)

func Asset(err error) {
	if err != nil {
		panic(err)
	}
}

// Exist check if the file with the given path exits.
func Exist(path string) bool {
	fi, err := os.Lstat(path)
	return fi != nil || (err != nil && !os.IsNotExist(err))
}

// https://github.com/fatih/gomodifytags
// https://github.com/favadi/protoc-go-inject-tag
// https://github.com/0xAX/go-algorithms
// https://github.com/emirpasic/gods
// https://github.com/gookit/goutil
// https://github.com/gookit/color
// https://github.com/creasty/defaults
// https://github.com/fatih/structtag
// https://github.com/fatih/gomodifytags
// https://github.com/Ompluscator/dynamic-struct
// https://github.com/jhump/protoreflect
// https://github.com/bufbuild/buf
// go get -u github.com/zekroTJA/timedmap
// https://github.com/m-zajac/json2go
// https://github.com/mitchellh/mapstructure
